#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=steg.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs
	Office 2007 Steganography ver 1.0
	From: Adrian Crenshaw http://irongeek.com
	Written in Autoit3

	This is some relatively crappy code I wrote to hide files inside of
	Microsoft Office 2007 docs (DOCX, XLSX, PPTX, etc). Since the newer Office
	docs are basically just zip files containing XML and resources, its fairly
	easy. I used torels_ zip library for Autoit. Please note, I do no
	encryption on the file inside of the doc, basically this program just:

	1.	Adds the file into the document.
	2.	Edits [Content_Types].xml so office programs dont complain about a corrupted file.

	If you save any changes in the Office document after you hide a file, the
	embedded file will be lost. This script just makes things more convenient
	than doing it all by hand. When you fire up the script, the program will
	ask for:
	1.	An office document (DOCX, XLSX, PPTX) to act as cover.
	2.	The file you wish to embed.
	The app will then create a file in the same directory as your cover file,
	with the prefix stego. To get back the embedded file just open the Office
	document in 7zip.

	Useful Links: http://en.wikipedia.org/wiki/Steganography

#ce

#include <File.au3>
#include "Zip.au3"

$MyOfficeDoc = FileOpenDialog("Choose your cover file, any Office 2007 XML format file (docx, xlsx, pptx):", "", "WordDocs(*.docx) PowerPoint(*.pptx) Excel(*.xlsx)")
$MyStuffToHide = FileOpenDialog("Choose file to hide in it:", "", "All(*.*)")
ZipSteg($MyOfficeDoc, $MyStuffToHide)

Func ZipSteg($CoverFile, $FileToAdd)
	$ZipFile = $CoverFile & ".zip"
	FileCopy($CoverFile, $ZipFile)
	$ctFile = @WorkingDir & "\[Content_Types].xml"
	$ctctFile = $ctFile & "\[Content_Types].xml"
	_Zip_Unzip($ZipFile, "[Content_Types].xml", $ctFile)
	_ReplaceStringInFile($ctctFile, "</Types>", "<Override PartName=""/" & JustFileName($FileToAdd) & """ ContentType=""" & JustFileName($FileToAdd) & """/></Types>")
	_Zip_AddFile($ZipFile, $FileToAdd, 0)
	_Zip_Delete($ZipFile, "[Content_Types].xml")
	_Zip_AddFile($ZipFile, $ctctFile, 0)
	DirRemove($ctFile, 1)
	$OutputFile = JustPath($ZipFile) & "stego " & JustFileName($CoverFile)
	FileMove($ZipFile, $OutputFile)
	;#ce
	MsgBox(0, "Done", $OutputFile & " created")
EndFunc   ;==>ZipSteg

Func JustFileName($FilePath)
	Return StringRight($FilePath, StringLen($FilePath) - StringInStr($FilePath, "\", 0, -1))
EndFunc   ;==>JustFileName

Func JustPath($FilePath)
	Return StringLeft($FilePath, StringInStr($FilePath, "\", 0, -1))
EndFunc   ;==>JustPath